-------------------------------------------------------------------------------
-- Master script to build seed database for Personal Oracle
-------------------------------------------------------------------------------
-- NOTES
--   DBA_AUTHORIZATION should be set to BYPASS in oracle.ini
--   or else user will have to answer prompts
-- MODIFICATIONS
--   rs  12/04/94 - Comment clean up for production

-------------------------------------------------------------------------------

-- spool information to log file --

set echo on
spool %rdbms71%\trace\build.log

-- create database, etc. Note, after creating DB, DB is mounted --

@%ORACLE_HOME%\dbs\build_db.sql

-- execute certain required .SQL , build data dictionary --

@%rdbms71%\admin\catalog
@%rdbms71%\admin\catalog6

-- only run next script for PL/SQL option
@%rdbms71%\admin\catproc

-- for snapshots
@%rdbms71%\admin\catsnap
@%rdbms71%\admin\dbmssnap

-- synonyms for system account
connect system/manager
@%rdbms71%\admin\catdbsyn
connect internal
@%rdbms71%\admin\catblock

-- execute V7PUP.SQL for oracle tools

@%ORACLE_HOME%\dbs\v7pup.sql

-- create user scott/tiger and create demo tables --

@%ORACLE_HOME%\dbs\scott.sql

-- shutdown database

connect internal
shutdown
spool off
