set echo on
spool %rdbms71%\trace\build.log

rem ==========================================================================
rem Instructions to build controlfile for starter database if things fail.
rem ==========================================================================
rem Sometimes while installing Personal Oracle the starter database may not
rem be built because of lack of memory. After installation follow these steps
rem to build controlfiles:
rem 1)In a DOS box or from the File Manager:
rem   delete ctl1.ora if present from your ORACLE_HOME\DBS  and
rem   ORACLE_HOME\RDBMS71\ARCHIVE locations
rem   delete wdblog1.ora and wdblog2.ora if present from ORACLE_HOME\DBS
rem   directory
rem 2)In Windows fire up sqldba32.exe
rem 3)At the "SQLDBA>" prompt run the install2.sql script located in your
rem   ORACLE_HOME\DBS directory.  For example if my ORACLE_HOME was c:\orawin
rem   I would type:
rem    @c:\orawin\dbs\install2.sql
rem
rem 4)You will be prompted for the password for the internal account.
rem 5)if you get no errors you are all set and can exit sqldba32.exe. if not
rem   look up the errors in the error codes manual and debug the problem.
rem ==========================================================================

set echo off

connect internal;
startup nomount pfile=%rdbms71%\inst.ora;

-- Create a new control file from the existing database files.
-- reset the log file name information in the control file,
-- but the new logs won't be created until we open the database
-- using the resetlogs option.

-- rs:  no archive logging for Windows DB
--      only multiplex control files (init.ora)
-- ksw: change so that we use the new environment variables,
--      change to multiplex the redo logs
--      change to turn on archive log mode

create controlfile reuse set database oracle
    datafile '%RDBMS71_CONTROL%\wdbsys.ora',
             '%RDBMS71_CONTROL%\wdbuser.ora',
             '%RDBMS71_CONTROL%\wdbtemp.ora',
             '%RDBMS71_CONTROL%\wdbrbs.ora'
    logfile  group 1 ('%RDBMS71_CONTROL%\wdblog1.ora') size 500K,
             group 2 ('%RDBMS71_CONTROL%\wdblog2.ora') size 500K resetlogs
    noarchivelog;

-- Now, open the database and recreate the log files.

alter database oracle open resetlogs;

shutdown;

spool off

